PrefaceImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class PrefaceImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.PrefaceImpl

- All Implemented Interfaces:
    Serializable, Cloneable, QPreface, MediaEntity, MetadataObject, InterchangeObject, Preface

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=12032,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="Preface",
                  aliases="Header",
                  description="The Preface class provides file-wide information and indexes.",
                  symbol="Preface")
      public class PrefaceImpl
      extends InterchangeObjectImpl
      implements Preface, QPreface, Serializable, Cloneable

  Implements file-wide information and indexes. An AAF file shall have exactly one header object.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

    - ### Fields inherited from interface tv.amwa.maj.model.Preface

      `OBJECTMODELVERSION_DEFAULT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PrefaceImpl()` Creates and initializes a header object, the root object of any AAF persistent unit such as a file or database representation.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addApplicationScheme(AUID applicationSchemeID)` Adds the identifier of an application metadata scheme to the set of schemes used in this file.
    `void` | `addDescriptiveScheme(AUID descriptiveSchemeID)` Adds the given descriptive metadata scheme identifier to the set of schemes of this preface, which identify the descriptive metadata schemes used in the file.
    `void` | `addEssenceContainer(AUID containerID)` Adds an essence container to the set of essence containers identifiers of this preface, which identify the internal essence containers used in the file.
    `void` | `addEssenceData(EssenceData essenceData)` Adds an essence data item to the content storage of this preface.
    `void` | `addPackage(Package packageToAdd)` Adds a package to the content storage of this preface.
    `void` | `appendIdentification(Identification identification)` Appends the given identification to the list of identifications of this preface, which each identify an application that created or modified the file.
    `void` | `clearApplicationSchemes()` Remove all application schemes from this preface, omitting this optional property.
    `void` | `clearDescriptiveSchemes()` Remove all descriptive schemes from this preface, omitting this optional property.
    `void` | `clearEssenceContainers()` Remove all essence containers from this preface, omitting this optional property.
    `void` | `clearIdentificationList()`
    `Preface` | `clone()` Create a cloned copy of this interchange object.
    `int` | `countApplicationSchemes()` Returns the number of application metadata schemes recorded in the preface for this file.
    `int` | `countDescriptiveSchemes()` Returns the total number of descriptive metadata schemes present for this preface, which identify the descriptive metadata schemes used in the file.
    `int` | `countEssenceContainers()` Returns the total number of essence containers of this preface, which identify the internal essence containers used in the file.
    `int` | `countEssenceData()` Returns the total number of essence data items stored in the content storage of this preface.
    `int` | `countIdentifications()` Returns the number of identifications in the preface, which each identify an application that created or modified the file.
    `int` | `countPackages(PackageKind packageKind)` Returns the number of matches for the given package kind within the content storage of this preface.
    `Set<? extends EssenceData>` | `enumEssenceData()` Returns a set of all essence data stored in the content storage of this preface.
    `Set<AUID>` | `getApplicationSchemes()` Returns the set of identifiers for application metadata schemes used in the file.
    `int` | `getArchiveDatabaseType()`
    `ByteOrder` | `getByteOrder()` Returns the byte order of the file this preface was read from.
    `ContentStorage` | `getContentStorageObject()` Returns the content storage of this preface.
    `Set<AUID>` | `getDescriptiveSchemes()` Returns the set of descriptive schemes of this preface, which identify the descriptive metadata schemes used in the file.
    `Set<String>` | `getDescriptiveSchemesStringSet()`
    `Dictionary` | `getDictionaries()` Returns the dictionary of this preface, which contains all the definitions of the file.
    `Set<AUID>` | `getEssenceContainers()` Returns the set of essence containers of this header, which identify the internal essence containers used in the file.
    `Set<String>` | `getEssenceContainersStringSet()`
    `Set<? extends EssenceData>` | `getEssenceData()` Returns all the essence data objects from the content storage of this preface.
    `Set<? extends EssenceData>` | `getEssenceData(CriteriaType mediaCriteria)` Returns a set of essence data from the content storage of this preface that matches the given media criteria.
    `TimeStamp` | `getFileLastModified()` Return the last modified time stamp of this preface, which specifies the time and date that this file was last modified.
    `String` | `getFileLastModifiedString()`
    `VersionType` | `getFormatVersion()` Return the file version property of the preface.
    `String` | `getFormatVersionString()`
    `Identification` | `getGeneration()` Gets the generation of this object, which identifies when this object was created or last modified.
    `Identification` | `getIdentificationAt(int index)` Retrieves the identification at the given index through the list of identifications of this preface, which each identify an application that created or modified the file.
    `List<Identification>` | `getIdentifications()` Returns the list of identifications contained within this preface, which each identify an application that created or modified the file.
    `Identification` | `getLastIdentification()` Returns the identification of the last application that modified the file.
    `AUID` | `getLinkedGenerationID()` Shortcut to get the AUID of the identification representing this object's generation.
    `ProductVersion` | `getMajApiVersion()` Return the version of the MAJ API currently running on this machine, which implements these interfaces.
    `int` | `getObjectModelVersion()` Returns the version of the persistent storage format for objects of this preface.
    `AUID` | `getOperationalPattern()` Returns the identifier of the MXF operational pattern or AAF protocol that the file of this preface complies with.
    `String` | `getOperationalPatternString()`
    `Set<? extends Package>` | `getPackages()` Returns all the packages stored in the content storage of this preface.
    `Set<? extends Package>` | `getPackages(SearchCriteria searchCriteria)` Returns a set of packages stored in the content storage of this preface that match the given `search criteria`.
    `Package` | `getPrimaryPackage()` Returns the primary package identifier for the file of this preface, which specifies the package that an MXF application treats as the default or primary package.
    `static ByteOrder` | `initializeByteOrder()`
    `static ContentStorage` | `initializeContentStorageObject()`
    `static Dictionary` | `initializeDictionaries()`
    `static TimeStamp` | `initializeFileLastModified()`
    `static VersionType` | `initializeFormatVersion()`
    `static List<Identification>` | `initializeIdentificationList()`
    `boolean` | `isApplicationSchemePresent(AUID applicationSchemeID)` Returns `true` if the given identifier matches one of the application metadata scheme stated to be in the file.
    `boolean` | `isDescriptiveSchemePresent(AUID descriptiveSchemeID)` Returns `true` if the descriptive metadata scheme with the given identifier is in set of schemes of this preface; otherwise `false`.
    `boolean` | `isEssenceContainerPresent(AUID essenceContainerID)` Returns `true` if the essence containers with the given identifier is present for this preface; otherwise `false`.
    `boolean` | `isEssenceDataPresent(PackageID filPackageID)` Returns `true` if essence data identified by the given package id is present in the content storage of this preface.
    `EssenceData` | `lookupEssenceData(PackageID packageID)` Looks up and returns the essence data that matches the given package id from the content storage of this preface.
    `Identification` | `lookupIdentification(AUID generation)` Returns the identification that matches the given generation identifier from the list of identifications of applications that created or modified the file of this preface.
    `Package` | `lookupPackage(PackageID packageID)` Returns the package that matches the given package id stored in the content storage of this preface.
    `void` | `prependIdentification(Identification ident)`
    `void` | `removeApplicationScheme(AUID applicationSchemeID)` Remove an application metadata scheme from the set of application schemes of this file.
    `void` | `removeDescriptiveScheme(AUID descriptiveSchemeID)` Removes the given descriptive metadata scheme identifier from the set of schemes of this preface, which identify the descriptive metadata schemes used in the file.
    `void` | `removeEssenceContainer(AUID essenceContainerID)`
    `void` | `removeEssenceData(EssenceData essenceData)` Removes the given essence data item from the content storage of this preface.
    `void` | `removePackage(Package packageToRemove)` Removes the given package from the content storage of this preface.
    `void` | `setArchiveDatabaseType(Integer archiveDatabaseType)`
    `void` | `setByteOrder(Object byteOrder)`
    `void` | `setContentStorageObject(ContentStorage contentStorageObject)`
    `void` | `setDescriptiveSchemesStringSet(Set<String> descriptiveSchemes)`
    `void` | `setDictionaries(Dictionary dictionaries)`
    `void` | `setEssenceContainersStringSet(Set<String> essenceContainers)`
    `void` | `setFileLastModified(TimeStamp fileLastModified)` Set the last modified time stamp of this preface, which specifies the time and date that this file was last modified.
    `void` | `setFileLastModifiedString(String fileLastModified)`
    `void` | `setFormatVersion(VersionType formatVersion)`
    `void` | `setFormatVersionString(String formatVersion)`
    `void` | `setObjectModelVersion(Integer objectModelVersion)`
    `void` | `setOperationalPattern(AUID operationalPatternID)` Sets the MXF operational pattern or AAF protocol that the file of this preface complies with.
    `void` | `setOperationPatternString(String operationalPattern)`
    `void` | `setPrimaryPackage(Package primaryPackage)` Sets the primary package identifier for the file of the preface, which specifies the package that an MXF application treats as the default or primary package.
    `boolean` | `updateDictionaries()` Iterate through the content storage packages and make sure the dictionary contains all the referenced definitions, adding any missing definitions.
    `void` | `updateEssenceContainers()` Ensures that the contents of the essence containers property is in sync with the file's metadata.

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getComment, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

- - ### Constructor Detail

    - #### PrefaceImpl

          public PrefaceImpl()

      Creates and initializes a header object, the root object of any AAF persistent unit such as a file or database representation.

  - ### Method Detail

    - #### addDescriptiveScheme

          @MediaSetAdd(value="DescriptiveSchemes")
          public void addDescriptiveScheme(AUID descriptiveSchemeID)
                                                                             throws NullPointerException

      Description copied from interface: `Preface`

      Adds the given descriptive metadata scheme identifier to the set of schemes of this preface, which identify the descriptive metadata schemes used in the file. If the optional set of descriptive metadata schemes property is omitted, it will become present after successful completion of this method.

      Specified by:
        `addDescriptiveScheme` in interface `Preface`
      Parameters:
        `descriptiveSchemeID` - Descriptive metadata scheme identifier to add to the set of this preface.
      Throws:
        `NullPointerException` - The given descriptive metadata scheme identifier is `null`.
      See Also:
        `DescriptiveFramework`, `DescriptiveClip`

    - #### addEssenceData

          public void addEssenceData(EssenceData essenceData)
                              throws DuplicatePackageIDException,
                                     NullPointerException

      Description copied from interface: `Preface`

      Adds an essence data item to the content storage of this preface.

      Specified by:
        `addEssenceData` in interface `Preface`
      Parameters:
        `essenceData` - Essence data to add to the content storage of this preface.
      Throws:
        `DuplicatePackageIDException` - Essence data with the same package id is already contained in the content storage of this preface.
        `NullPointerException` - The given essence data item is `null`.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.addEssenceDataObject(EssenceData)`

    - #### addPackage

          public void addPackage(Package packageToAdd)
                          throws NullPointerException,
                                 DuplicatePackageIDException

      Description copied from interface: `Preface`

      Adds a package to the content storage of this preface.

      Specified by:
        `addPackage` in interface `Preface`
      Parameters:
        `packageToAdd` - Package to add to the content storage of this preface.
      Throws:
        `NullPointerException` - The given package is `null`.
        `DuplicatePackageIDException` - A package with the same package id is already contained in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.addPackage(Package)`

    - #### appendIdentification

          @MediaListAppend(value="IdentificationList")
          public void appendIdentification(Identification identification)
                                                                                 throws NullPointerException

      Description copied from interface: `Preface`

      Appends the given identification to the list of identifications of this preface, which each identify an application that created or modified the file. The identification at the end of the list should represent the most recent application to modify the file. This method does not attempt to identify duplicate identifications, so it will succeed even if an identical identification is already contained in the list.

      Specified by:
        `appendIdentification` in interface `Preface`
      Parameters:
        `identification` - Identification to append to the list of identifications of this preface.
      Throws:
        `NullPointerException` - The given identification is `null`.

    - #### prependIdentification

          @MediaListPrepend(value="IdentificationList")
          public void prependIdentification(Identification ident)
                                                                                   throws NullPointerException

      Throws:
        `NullPointerException`

    - #### countDescriptiveSchemes

          @MediaPropertyCount(value="DescriptiveSchemes")
          public int countDescriptiveSchemes()

      Description copied from interface: `Preface`

      Returns the total number of descriptive metadata schemes present for this preface, which identify the descriptive metadata schemes used in the file.

      Specified by:
        `countDescriptiveSchemes` in interface `Preface`
      Returns:
        Total number of descriptive schemes present in the file of this preface.

    - #### countEssenceContainers

          @MediaPropertyCount(value="EssenceContainers")
          public int countEssenceContainers()
                                                                                    throws PropertyNotPresentException

      Description copied from interface: `Preface`

      Returns the total number of essence containers of this preface, which identify the internal essence containers used in the file.

      Specified by:
        `countEssenceContainers` in interface `Preface`
      Returns:
        Total number of essence containers present in the file of the preface.
      Throws:
        `PropertyNotPresentException` - Essence containers are not present in the file of the preface.

    - #### countEssenceData

          public int countEssenceData()

      Description copied from interface: `Preface`

      Returns the total number of essence data items stored in the content storage of this preface.

      Specified by:
        `countEssenceData` in interface `Preface`
      Returns:
        Total number of essence data items stored in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.countEssenceDataObjects()`

    - #### countIdentifications

          @MediaPropertyCount(value="IdentificationList")
          public int countIdentifications()

      Description copied from interface: `Preface`

      Returns the number of identifications in the preface, which each identify an application that created or modified the file.

      Specified by:
        `countIdentifications` in interface `Preface`
      Returns:
        Number of identifications in the list of identifications of this preface.

    - #### clearIdentificationList

          @MediaPropertyClear(value="IdentificationList")
          public void clearIdentificationList()

    - #### countPackages

          public int countPackages(PackageKind packageKind)
                            throws NullPointerException

      Description copied from interface: `Preface`

      Returns the number of matches for the given package kind within the content storage of this preface. Use `PackageKind.AllPackages` to count the total number of packages.

      Specified by:
        `countPackages` in interface `Preface`
      Parameters:
        `packageKind` - The kind of packages to count.
      Returns:
        Total number of packages matching the given package kind in the content storage of this preface.
      Throws:
        `NullPointerException`
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.countPackages(PackageKind)`

    - #### enumEssenceData

          public Set<? extends EssenceData> enumEssenceData()

      Description copied from interface: `Preface`

      Returns a set of all essence data stored in the content storage of this preface.

      Specified by:
        `enumEssenceData` in interface `Preface`
      Returns:
        Shallow copy of the set of all essence data stored in the content storage of this preface.
      See Also:
        `Preface.getEssenceData(CriteriaType)`, `Preface.getContentStorageObject()`, `ContentStorage.enumEssenceDataObjects()`

    - #### getContentStorageObject

          @MediaProperty(uuid1=100729092,
                         uuid2=513,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="ContentStorageObject",
                         aliases="Content",
                         typeName="ContentStorageStrongReference",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15107,
                         symbol="ContentStorageObject")
          public ContentStorage getContentStorageObject()

      Description copied from interface: `Preface`

      Returns the content storage of this preface. This is the Content property of a preface.

      Specified by:
        `getContentStorageObject` in interface `Preface`
      Returns:
        Content storage of this object.

    - #### setContentStorageObject

          @MediaPropertySetter(value="ContentStorageObject")
          public void setContentStorageObject(ContentStorage contentStorageObject)
                                                                                          throws NullPointerException

      Throws:
        `NullPointerException`

    - #### initializeContentStorageObject

          public static final ContentStorage initializeContentStorageObject()

    - #### getDescriptiveSchemes

          @MediaProperty(uuid1=16908816,
                         uuid2=514,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="DescriptiveSchemes",
                         aliases="DMSchemes",
                         typeName="AUIDSet",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15115,
                         symbol="DescriptiveSchemes")
          public Set<AUID> getDescriptiveSchemes()
                                                                                                                                                                                                                                                                                                                                                                                                                                          throws PropertyNotPresentException

      Description copied from interface: `Preface`

      Returns the set of descriptive schemes of this preface, which identify the descriptive metadata schemes used in the file.

      Specified by:
        `getDescriptiveSchemes` in interface `Preface`
      Returns:
        Copy of the identifiers of the descriptive schemes of this preface.
      Throws:
        `PropertyNotPresentException` - The optional set of descriptive metadata schemes is not present in this preface.
      See Also:
        `DescriptiveFramework`, `DescriptiveClip`, `Root.getRootExtensions()`, `DescriptiveMarker.getDescriptiveMetadataScheme()`, `ExtensionScheme`

    - #### clearDescriptiveSchemes

          @MediaPropertyClear(value="DescriptiveSchemes")
          public void clearDescriptiveSchemes()

      Description copied from interface: `Preface`

      Remove all descriptive schemes from this preface, omitting this optional property.

      Specified by:
        `clearDescriptiveSchemes` in interface `Preface`
      See Also:
        `Preface.getDescriptiveSchemes()`, `Preface.countDescriptiveSchemes()`

    - #### getEssenceContainers

          @MediaProperty(uuid1=16908816,
                         uuid2=513,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="EssenceContainers",
                         typeName="AUIDSet",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15114,
                         symbol="EssenceContainers")
          public Set<AUID> getEssenceContainers()
                                                                                                                                                                                                                                                                                                                                                                                                  throws PropertyNotPresentException

      Returns the set of essence containers of this header, which identify the internal essence containers used in the file. This is an optional property that is automatically maintained.

      Specified by:
        `getEssenceContainers` in interface `Preface`
      Returns:
        Copy of the identifiers for the internal essence containers of this header. The identifiers are cloned.
      Throws:
        `PropertyNotPresentException` - The optional set of essence containers is not present for this preface.
      See Also:
        `ContainerConstant`, `ContainerDefinition`

    - #### addEssenceContainer

          @MediaSetAdd(value="EssenceContainers")
          public void addEssenceContainer(AUID containerID)
                                                                           throws NullPointerException

      Description copied from interface: `Preface`

      Adds an essence container to the set of essence containers identifiers of this preface, which identify the internal essence containers used in the file. The essence container property is optional. Adding an optional identifier causes the essence containers property to become present.

      Specified by:
        `addEssenceContainer` in interface `Preface`
      Parameters:
        `containerID` - Essence container identifier to add to the set of essence containers of this prefance.
      Throws:
        `NullPointerException` - Cannot add a null identifier to the set of essence containers.
      See Also:
        `DefinitionObject.getAUID()`, `Preface.getEssenceContainers()`, `Preface.isEssenceContainerPresent(AUID)`

    - #### removeEssenceContainer

          @MediaPropertyRemove(value="EssenceContainers")
          public void removeEssenceContainer(AUID essenceContainerID)
                                                                                      throws NullPointerException,
                                                                                             InvalidParameterException,
                                                                                             PropertyNotPresentException

      Throws:
        `NullPointerException`
        `InvalidParameterException`
        `PropertyNotPresentException`

    - #### clearEssenceContainers

          @MediaPropertyClear(value="EssenceContainers")
          public void clearEssenceContainers()

      Description copied from interface: `Preface`

      Remove all essence containers from this preface, omitting this optional property.

      Specified by:
        `clearEssenceContainers` in interface `Preface`
      See Also:
        `Preface.getEssenceContainers()`, `Preface.countEssenceContainers()`

    - #### getEssenceData

          public Set<? extends EssenceData> getEssenceData(CriteriaType mediaCriteria)
                                                    throws NullPointerException

      Description copied from interface: `Preface`

      Returns a set of essence data from the content storage of this preface that matches the given media criteria. If the media criteria is CriteriaType.AnyRepresentation then all essence data that is stored in the content storage of this preface is included, producing the same result as calling `Preface.enumEssenceData()`.

      Specified by:
        `getEssenceData` in interface `Preface`
      Parameters:
        `mediaCriteria` - Criteria for selecting essence data from storage.
      Returns:
        Set of essence data matching the criteria that is stored in the content storage of this preface. Note that the essence data items are not cloned.
      Throws:
        `NullPointerException`
      See Also:
        `Preface.getEssenceData()`, `Preface.enumEssenceData()`, `Preface.getContentStorageObject()`, `ContentStorage.getEssenceDataObjects(CriteriaType)`

    - #### getEssenceData

          public Set<? extends EssenceData> getEssenceData()

      Description copied from interface: `Preface`

      Returns all the essence data objects from the content storage of this preface.

      Specified by:
        `getEssenceData` in interface `Preface`
      Returns:
        Set of all the essence data objects from the content storage of this preface.
      See Also:
        `Preface.enumEssenceData()`, `Preface.getEssenceData(CriteriaType)`, `ContentStorage.getEssenceDataObjects()`

    - #### getFormatVersion

          @MediaProperty(uuid1=50397697,
                         uuid2=1280,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="FormatVersion",
                         aliases="Version",
                         typeName="VersionType",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15109,
                         symbol="FormatVersion")
          public VersionType getFormatVersion()

      Description copied from interface: `Preface`

      Return the file version property of the preface.

      Specified by:
        `getFormatVersion` in interface `Preface`
      Returns:
        File version.

    - #### setFormatVersion

          @MediaPropertySetter(value="FormatVersion")
          public void setFormatVersion(VersionType formatVersion)
                                                                            throws NullPointerException

      Throws:
        `NullPointerException`

    - #### initializeFormatVersion

          public static final VersionType initializeFormatVersion()

    - #### getIdentificationAt

          @MediaListGetAt(value="IdentificationList")
          public Identification getIdentificationAt(int index)
                                                                                         throws IndexOutOfBoundsException

      Description copied from interface: `Preface`

      Retrieves the identification at the given index through the list of identifications of this preface, which each identify an application that created or modified the file.

      Specified by:
        `getIdentificationAt` in interface `Preface`
      Parameters:
        `index` - 0-based index of the identification to retrieve from the list of identifications of this preface.
      Returns:
        Identification at the given index.
      Throws:
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of identifications of this preface.

    - #### getIdentifications

          @MediaProperty(uuid1=100729092,
                         uuid2=1540,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="IdentificationList",
                         typeName="IdentificationStrongReferenceVector",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15110,
                         symbol="IdentificationList")
          public List<Identification> getIdentifications()

      Description copied from interface: `Preface`

      Returns the list of identifications contained within this preface, which each identify an application that created or modified the file.

      Specified by:
        `getIdentifications` in interface `Preface`
      Returns:
        Shallow copy of the list of identifications in this preface.
      See Also:
        `TypeDefinitions.IdentificationStrongReferenceVector`

    - #### initializeIdentificationList

          public static final List<Identification> initializeIdentificationList()

    - #### getLastIdentification

          public Identification getLastIdentification()

      Description copied from interface: `Preface`

      Returns the identification of the last application that modified the file.

      Specified by:
        `getLastIdentification` in interface `Preface`
      Returns:
        Identification of last application that modified the file.

    - #### getFileLastModified

          @MediaProperty(uuid1=117571856,
                         uuid2=516,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="FileLastModified",
                         aliases="LastModified",
                         typeName="TimeStamp",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15106,
                         symbol="FileLastModified")
          public TimeStamp getFileLastModified()

      Description copied from interface: `Preface`

      Return the last modified time stamp of this preface, which specifies the time and date that this file was last modified.

      Specified by:
        `getFileLastModified` in interface `Preface`
      Returns:
        Last modification time stamp.

    - #### setFileLastModified

          @MediaPropertySetter(value="FileLastModified")
          public void setFileLastModified(TimeStamp fileLastModified)
                                                                                  throws NullPointerException

      Description copied from interface: `Preface`

      Set the last modified time stamp of this preface, which specifies the time and date that this file was last modified. This value should match that of the `most recent identification`.

      Specified by:
        `setFileLastModified` in interface `Preface`
      Parameters:
        `fileLastModified` - Time stamp for the most recent modification of the file.
      Throws:
        `NullPointerException` - Cannot set the timestamp using a `null` value.
      See Also:
        `Preface.getLastIdentification()`

    - #### initializeFileLastModified

          public static final TimeStamp initializeFileLastModified()

    - #### getPackages

          public Set<? extends Package> getPackages(SearchCriteria searchCriteria)

      Description copied from interface: `Preface`

      Returns a set of packages stored in the content storage of this preface that match the given `search criteria`. If the search criteria is `null`, all packages are returned.

      Specified by:
        `getPackages` in interface `Preface`
      Parameters:
        `searchCriteria` - Search criteria to use to filter the set of packages returned.
      Returns:
        Set of packages matching the search criteria, or the set of all packages if the search criteria was `null`. The set does not clone packages it contains.
      See Also:
        `Preface.getContentStorageObject()`, `Preface.getPackages()`, `ContentStorage.getPackages(SearchCriteria)`, `ContentStorage.getPackages()`

    - #### getPackages

          public Set<? extends Package> getPackages()

      Description copied from interface: `Preface`

      Returns all the packages stored in the content storage of this preface.

      Specified by:
        `getPackages` in interface `Preface`
      Returns:
        Set of all packages stored in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `Preface.getPackages(SearchCriteria)`, `ContentStorage.getPackages()`

    - #### getOperationalPattern

          @MediaProperty(uuid1=16908803,
                         uuid2=0,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="OperationalPattern",
                         typeName="AUID",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15113,
                         symbol="OperationalPattern")
          public AUID getOperationalPattern()
                                                                                                                                                                                                                                                                                                                                                                                           throws PropertyNotPresentException

      Description copied from interface: `Preface`

      Returns the identifier of the MXF operational pattern or AAF protocol that the file of this preface complies with. This is an optional property.

      Specified by:
        `getOperationalPattern` in interface `Preface`
      Returns:
        Operational pattern that the file of this preface complies with.
      Throws:
        `PropertyNotPresentException` - Property is not present in the preface.
      See Also:
        `OperationalPatternConstant`

    - #### setOperationalPattern

          @MediaPropertySetter(value="OperationalPattern")
          public void setOperationalPattern(AUID operationalPatternID)

      Description copied from interface: `Preface`

      Sets the MXF operational pattern or AAF protocol that the file of this preface complies with. Set this optional property to `null` to omit it.

      Specified by:
        `setOperationalPattern` in interface `Preface`
      Parameters:
        `operationalPatternID` - Operational pattern identifier for the preface.
      See Also:
        `OperationalPatternConstant`

    - #### getPrimaryPackage

          @MediaProperty(uuid1=100729092,
                         uuid2=264,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,4},
                         definedName="PrimaryPackage",
                         typeName="PackageWeakReference",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15112,
                         symbol="PrimaryPackage")
          public Package getPrimaryPackage()
                                                                                                                                                                                                                                                                                                                                                                                                     throws PropertyNotPresentException

      Description copied from interface: `Preface`

      Returns the primary package identifier for the file of this preface, which specifies the package that an MXF application treats as the default or primary package. This is an optional property.

      Specified by:
        `getPrimaryPackage` in interface `Preface`
      Returns:
        Primary package identifier for the file of this preface.
      Throws:
        `PropertyNotPresentException` - The optional primary package identifier is not present in the preface.
      See Also:
        `PackageID.getMaterial()`

    - #### setPrimaryPackage

          @MediaPropertySetter(value="PrimaryPackage")
          public void setPrimaryPackage(Package primaryPackage)

      Description copied from interface: `Preface`

      Sets the primary package identifier for the file of the preface, which specifies the package that an MXF application treats as the default or primary package. Set this optional property to `null` to omit it.

      Specified by:
        `setPrimaryPackage` in interface `Preface`
      Parameters:
        `primaryPackage` - Primary package identifier for the file of this preface.
      See Also:
        `PackageID.getMaterial()`

    - #### getMajApiVersion

          public ProductVersion getMajApiVersion()

      Description copied from interface: `Preface`

      Return the version of the MAJ API currently running on this machine, which implements these interfaces.

      Specified by:
        `getMajApiVersion` in interface `Preface`
      Returns:
        MAJ API version.
      See Also:
        `Preface.getLastIdentification()`, `Identification.getRefImplVersion()`

    - #### isDescriptiveSchemePresent

          @MediaPropertyContains(value="DescriptiveSchemes")
          public boolean isDescriptiveSchemePresent(AUID descriptiveSchemeID)
                                                                                                throws NullPointerException

      Description copied from interface: `Preface`

      Returns `true` if the descriptive metadata scheme with the given identifier is in set of schemes of this preface; otherwise `false`.

      Specified by:
        `isDescriptiveSchemePresent` in interface `Preface`
      Parameters:
        `descriptiveSchemeID` - Identifier of the descriptive metadata scheme to check for.
      Returns:
        Does the given identifier match that of a descriptive metadata scheme in this preface?
      Throws:
        `NullPointerException` - The given identifier is `null`.
      See Also:
        `DescriptiveFramework`, `DescriptiveClip`

    - #### isEssenceContainerPresent

          @MediaPropertyContains(value="EssenceContainers")
          public boolean isEssenceContainerPresent(AUID essenceContainerID)
                                                                                              throws NullPointerException

      Description copied from interface: `Preface`

      Returns `true` if the essence containers with the given identifier is present for this preface; otherwise `false`. The set of essence containers identify the internal essence containers used in the file. The essence containers property of a preface is optional.

      Specified by:
        `isEssenceContainerPresent` in interface `Preface`
      Parameters:
        `essenceContainerID` - Identifier of the type of essence container to check for.
      Returns:
        Is the given essence container identifier in this preface?
      Throws:
        `NullPointerException` - The given identifier is `null`.
      See Also:
        `ContainerConstant`, `ContainerDefinition`, `DefinitionObject.getAUID()`

    - #### isEssenceDataPresent

          public boolean isEssenceDataPresent(PackageID filPackageID)
                                       throws NullPointerException,
                                              InvalidParameterException

      Description copied from interface: `Preface`

      Returns `true` if essence data identified by the given package id is present in the content storage of this preface.

      Specified by:
        `isEssenceDataPresent` in interface `Preface`
      Parameters:
        `filPackageID` - Identifier of a file package that may be present in the content storage of this preface.
      Returns:
        Does the given package id match that of an essence data item stored in thie content storage of this preface?
      Throws:
        `NullPointerException` - The given package id is `null`.
        `InvalidParameterException` - The given file package id does not identify a file source package.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.isEssenceDataPresent(PackageID)`

    - #### lookupEssenceData

          public EssenceData lookupEssenceData(PackageID packageID)
                                        throws NullPointerException,
                                               PackageNotFoundException

      Description copied from interface: `Preface`

      Looks up and returns the essence data that matches the given package id from the content storage of this preface.

      Specified by:
        `lookupEssenceData` in interface `Preface`
      Parameters:
        `packageID` - Identifier for essence data stored in the content storage of this preface.
      Returns:
        Essence data stored in the content storage of this preface with the given package id.
      Throws:
        `NullPointerException` - The given package id is `null`.
        `PackageNotFoundException` - Essence data identified with the given package id is not stored in the content storage of the preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.lookupEssenceDataObject(PackageID)`

    - #### lookupIdentification

          public Identification lookupIdentification(AUID generation)
                                              throws NullPointerException,
                                                     ObjectNotFoundException

      Description copied from interface: `Preface`

      Returns the identification that matches the given generation identifier from the list of identifications of applications that created or modified the file of this preface.

      Specified by:
        `lookupIdentification` in interface `Preface`
      Parameters:
        `generation` - Unique generation identifier to retrieve from the list of identifications of this preface.
      Returns:
        Identification with the given identifier from the list of identifications of this preface.
      Throws:
        `NullPointerException` - The given generation identifier is `null`.
        `ObjectNotFoundException` - An identification with the given identifier was not found in the list of identifications of this preface.

    - #### lookupPackage

          public Package lookupPackage(PackageID packageID)
                                throws NullPointerException,
                                       PackageNotFoundException

      Description copied from interface: `Preface`

      Returns the package that matches the given package id stored in the content storage of this preface.

      Specified by:
        `lookupPackage` in interface `Preface`
      Parameters:
        `packageID` - The identifier of the package to look up in the content storage of this preface.
      Returns:
        The package from the storage with the matching identifier.
      Throws:
        `NullPointerException` - The given package identifier is `null`.
        `PackageNotFoundException` - A package with the given identifier was not found in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.lookupPackage(PackageID)`

    - #### removeDescriptiveScheme

          @MediaPropertyRemove(value="DescriptiveSchemes")
          public void removeDescriptiveScheme(AUID descriptiveSchemeID)
                                                                                        throws NullPointerException,
                                                                                               InvalidParameterException,
                                                                                               PropertyNotPresentException

      Description copied from interface: `Preface`

      Removes the given descriptive metadata scheme identifier from the set of schemes of this preface, which identify the descriptive metadata schemes used in the file. If the

      Specified by:
        `removeDescriptiveScheme` in interface `Preface`
      Parameters:
        `descriptiveSchemeID` - Descriptive metadata scheme identifier to remove from the set of schemes of this preface.
      Throws:
        `NullPointerException` - The given scheme identifier is `null`.
        `InvalidParameterException` - The given descriptive scheme identifier is not present in the list of schemes of this preface.
        `PropertyNotPresentException` - The optional set of descriptive metadata schemes property is not present in this preface.
      See Also:
        `DescriptiveFramework`, `DescriptiveClip`

    - #### removeEssenceData

          public void removeEssenceData(EssenceData essenceData)
                                 throws NullPointerException,
                                        EssenceNotFoundException

      Description copied from interface: `Preface`

      Removes the given essence data item from the content storage of this preface.

      Specified by:
        `removeEssenceData` in interface `Preface`
      Parameters:
        `essenceData` - Essence data to remove from the content storage of this preface.
      Throws:
        `NullPointerException` - The given essence data item is `null`.
        `EssenceNotFoundException` - The given essence data item is not contained in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.removeEssenceDataObject(EssenceData)`

    - #### removePackage

          public void removePackage(Package packageToRemove)
                             throws NullPointerException,
                                    PackageNotFoundException

      Description copied from interface: `Preface`

      Removes the given package from the content storage of this preface.

      Specified by:
        `removePackage` in interface `Preface`
      Parameters:
        `packageToRemove` - Package to remove from the preface.
      Throws:
        `NullPointerException` - The given package to remove is `null`.
        `PackageNotFoundException` - The given package is not contained in the content storage of this preface.
      See Also:
        `Preface.getContentStorageObject()`, `ContentStorage.removePackage(Package)`

    - #### updateEssenceContainers

          public void updateEssenceContainers()

      Description copied from interface: `Preface`

      Ensures that the contents of the essence containers property is in sync with the file's metadata. If this method succeeds, the essence containers property will contain identifiers of all container definitions referenced by `source packages` in the file of the preface.

      If the property isn't present it will be created. It is recommended that this method is called before any other of the methods affecting the essence containers can be called.

      Specified by:
        `updateEssenceContainers` in interface `Preface`
      See Also:
        `ContainerDefinition`

    - #### getGeneration

          public Identification getGeneration()
                                       throws InvalidParameterException,
                                              ObjectNotAttachedException

      Description copied from interface: `InterchangeObject`

      Gets the generation of this object, which identifies when this object was created or last modified.

      This method will succeed if generation tracking is enabled for this object. Call `InterchangeObject.enableGenerationTracking()` and `InterchangeObject.disableGenerationTracking()` to control generation tracking for this object. Call `InterchangeObject.isGenerationTracked()` to determine if generation tracking is currently enabled for this object.

      Specified by:
        `getGeneration` in interface `InterchangeObject`
      Overrides:
        `getGeneration` in class `InterchangeObjectImpl`
      Returns:
        Identification for when this object was last modified.
      Throws:
        `InvalidParameterException` - Generation tracking is not enabled for this object.
        `ObjectNotAttachedException` - This object is not attached to a file from which generation information can be obtained.

    - #### getLinkedGenerationID

          public AUID getLinkedGenerationID()

      Description copied from interface: `InterchangeObject`

      Shortcut to get the AUID of the identification representing this object's generation.

      This method will succeed if generation tracking is enabled for this object. Call `InterchangeObject.enableGenerationTracking()` and `InterchangeObject.disableGenerationTracking()` to control generation tracking for this object. Call `InterchangeObject.isGenerationTracked()` to determine if generation tracking is currently enabled for this object.

      Specified by:
        `getLinkedGenerationID` in interface `InterchangeObject`
      Overrides:
        `getLinkedGenerationID` in class `InterchangeObjectImpl`
      Returns:
        AUID of the identification representing this object's generation.
      See Also:
        `InterchangeObject.getGeneration()`, `InterchangeObject.getLinkedGenerationID()`

    - #### getByteOrder

          @MediaProperty(uuid1=50397697,
                         uuid2=512,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,1},
                         definedName="ByteOrder",
                         typeName="Int16",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15105,
                         symbol="ByteOrder")
          public ByteOrder getByteOrder()

      Description copied from interface: `Preface`

      Returns the byte order of the file this preface was read from.

      Specified by:
        `getByteOrder` in interface `Preface`
      Returns:
        Byte order of the file this preface was read from.
      See Also:
        `ByteOrder.getAAFByteOrderCode()`

    - #### setByteOrder

          @MediaPropertySetter(value="ByteOrder")
          public void setByteOrder(Object byteOrder)
                                                                    throws NullPointerException

      Throws:
        `NullPointerException`

    - #### initializeByteOrder

          public static final ByteOrder initializeByteOrder()

    - #### getDictionaries

          @MediaProperty(uuid1=100729092,
                         uuid2=514,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="Dictionaries",
                         aliases={"Dictionary","HeaderDictionary"},
                         typeName="DictionaryStrongReference",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=15108,
                         symbol="Dictionaries")
          public Dictionary getDictionaries()

      Description copied from interface: `Preface`

      Returns the dictionary of this preface, which contains all the definitions of the file. The dictionary is automatically created when the preface object is created.

      Specified by:
        `getDictionaries` in interface `Preface`
      Returns:
        AAF dictionary of the preface.
      See Also:
        `TypeDefinitions.DictionaryStrongReference`

    - #### setDictionaries

          @MediaPropertySetter(value="Dictionaries")
          public void setDictionaries(Dictionary dictionaries)
                                                                          throws NullPointerException

      Throws:
        `NullPointerException`

    - #### initializeDictionaries

          public static final Dictionary initializeDictionaries()

    - #### getObjectModelVersion

          @MediaProperty(uuid1=50397697,
                         uuid2=1024,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="ObjectModelVersion",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15111,
                         symbol="ObjectModelVersion")
          public int getObjectModelVersion()

      Description copied from interface: `Preface`

      Returns the version of the persistent storage format for objects of this preface.

      Specified by:
        `getObjectModelVersion` in interface `Preface`
      Returns:
        Version of the persistent storage format for objects.

    - #### setObjectModelVersion

          @MediaPropertySetter(value="ObjectModelVersion")
          public void setObjectModelVersion(Integer objectModelVersion)
                                                                                      throws IllegalArgumentException

      Throws:
        `IllegalArgumentException`

    - #### getApplicationSchemes

          @MediaProperty(uuid1=16908816,
                         uuid2=515,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,12},
                         definedName="ApplicationSchemes",
                         aliases={"ApplicationMetadataSchemes","ApplicationSchemesBatch"},
                         typeName="AUIDSet",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         symbol="ApplicationSchemes")
          public Set<AUID> getApplicationSchemes()
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   throws PropertyNotPresentException

      Description copied from interface: `Preface`

      Returns the set of identifiers for application metadata schemes used in the file. This is an optional property.

      Specified by:
        `getApplicationSchemes` in interface `Preface`
      Returns:
        Set of identifiers for application metadata schemes used in the file.
      Throws:
        `PropertyNotPresentException` - The optional application schemes property is not present in this preface.
      See Also:
        `Preface.isApplicationSchemePresent(AUID)`, `Preface.addApplicationScheme(AUID)`, `ExtensionScheme`

    - #### addApplicationScheme

          @MediaSetAdd(value="ApplicationSchemes")
          public void addApplicationScheme(AUID applicationSchemeID)
                                                                             throws NullPointerException

      Description copied from interface: `Preface`

      Adds the identifier of an application metadata scheme to the set of schemes used in this file. If this optional property is omitted, successful completion of this property will make the property present.

      Specified by:
        `addApplicationScheme` in interface `Preface`
      Parameters:
        `applicationSchemeID` - Application metadata scheme identifier to add.
      Throws:
        `NullPointerException` - Cannot add a `null` identifier to the set of application schemes.
      See Also:
        `Preface.getApplicationSchemes()`, `Preface.isApplicationSchemePresent(AUID)`

    - #### clearApplicationSchemes

          @MediaPropertyClear(value="ApplicationSchemes")
          public void clearApplicationSchemes()

      Description copied from interface: `Preface`

      Remove all application schemes from this preface, omitting this optional property.

      Specified by:
        `clearApplicationSchemes` in interface `Preface`
      See Also:
        `Preface.getApplicationSchemes()`, `Preface.countApplicationSchemes()`

    - #### countApplicationSchemes

          @MediaPropertyCount(value="ApplicationScehemes")
          public int countApplicationSchemes()

      Description copied from interface: `Preface`

      Returns the number of application metadata schemes recorded in the preface for this file.

      Specified by:
        `countApplicationSchemes` in interface `Preface`
      Returns:
        Number of application metadata schemes of this preface.
      See Also:
        `Preface.getApplicationSchemes()`

    - #### isApplicationSchemePresent

          @MediaPropertyContains(value="ApplicationSchemes")
          public boolean isApplicationSchemePresent(AUID applicationSchemeID)
                                                                                                throws PropertyNotPresentException,
                                                                                                       NullPointerException

      Description copied from interface: `Preface`

      Returns `true` if the given identifier matches one of the application metadata scheme stated to be in the file.

      Specified by:
        `isApplicationSchemePresent` in interface `Preface`
      Parameters:
        `applicationSchemeID` - Application scheme identifier for check for.
      Returns:
        Does the given identifier match that of an application metadata scheme in this preface?
      Throws:
        `PropertyNotPresentException` - The optional application schemes property is not present in this preface.
        `NullPointerException` - Cannot test for an application scheme using a `null` pointer.
      See Also:
        `Preface.getApplicationSchemes()`

    - #### removeApplicationScheme

          @MediaPropertyRemove(value="ApplicationSchemes")
          public void removeApplicationScheme(AUID applicationSchemeID)
                                                                                        throws NullPointerException,
                                                                                               InvalidParameterException,
                                                                                               PropertyNotPresentException

      Description copied from interface: `Preface`

      Remove an application metadata scheme from the set of application schemes of this file.

      Specified by:
        `removeApplicationScheme` in interface `Preface`
      Parameters:
        `applicationSchemeID` - Identifier of the application metadata scheme to remove.
      Throws:
        `NullPointerException` - Cannot remove an application metadata schemes using a `null` identifier.
        `InvalidParameterException` - The given application metadata scheme identifier is not present in the set of application schemes of this preface.
        `PropertyNotPresentException` - The optional application schemes property is not present for this preface.
      See Also:
        `Preface.getApplicationSchemes()`, `Preface.isApplicationSchemePresent(AUID)`

    - #### updateDictionaries

          public boolean updateDictionaries()

      Description copied from interface: `Preface`

      Iterate through the content storage packages and make sure the dictionary contains all the referenced definitions, adding any missing definitions.

      Specified by:
        `updateDictionaries` in interface `Preface`
      Returns:
        Does the dictionary now contain all of the required definitions?
      See Also:
        `Preface.getDictionaries()`

    - #### clone

          public Preface clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `Preface`
      Overrides:
        `clone` in class `InterchangeObjectImpl`
      Returns:
        Cloned copy of this interchange object.

    - #### getFileLastModifiedString

          public String getFileLastModifiedString()

    - #### setFileLastModifiedString

          public void setFileLastModifiedString(String fileLastModified)

    - #### getFormatVersionString

          public String getFormatVersionString()

    - #### setFormatVersionString

          public void setFormatVersionString(String formatVersion)

    - #### getOperationalPatternString

          public String getOperationalPatternString()

    - #### setOperationPatternString

          public void setOperationPatternString(String operationalPattern)

    - #### getEssenceContainersStringSet

          public Set<String> getEssenceContainersStringSet()

    - #### setEssenceContainersStringSet

          public void setEssenceContainersStringSet(Set<String> essenceContainers)

    - #### getDescriptiveSchemesStringSet

          public Set<String> getDescriptiveSchemesStringSet()

    - #### setDescriptiveSchemesStringSet

          public void setDescriptiveSchemesStringSet(Set<String> descriptiveSchemes)

    - #### getArchiveDatabaseType

          @MediaProperty(uuid1=-718985234,
                         uuid2=-17763,
                         uuid3=19755,
                         uuid4={-110,-66,-23,58,42,7,61,102},
                         definedName="Archive database type",
                         symbol="Archive_database_type",
                         aliases="Archive_database_type",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getArchiveDatabaseType()
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        throws PropertyNotPresentException

      Specified by:
        `getArchiveDatabaseType` in interface `QPreface`
      Throws:
        `PropertyNotPresentException`

    - #### setArchiveDatabaseType

          @MediaPropertySetter(value="Archive database type")
          public void setArchiveDatabaseType(@Int32
                                                                                                 Integer archiveDatabaseType)

      Specified by:
        `setArchiveDatabaseType` in interface `QPreface`

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.